/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2010 by TAKAGI Nobuhisa  
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */

/*!
 *  \file   toppers/c_pp_line.hpp
 *  \brief  \#line˴ؤ
 */
#ifndef TOPPERS_C_PP_LINE_HPP_
#define TOPPERS_C_PP_LINE_HPP_

#include "toppers/text_line.hpp"
#include "toppers/c_parser.hpp"
#include "toppers/workaround.hpp"
#include <vector>
#include <functional>

namespace toppers
{

  namespace detail
  {

    //! \#line ιʸ
    struct c_pp_line_parser : boost::spirit::grammar< c_pp_line_parser >
    {
      template < class Scanner >
      struct definition
      {
        typedef boost::spirit::rule< Scanner > rule_t;
        rule_t r;
        definition( c_pp_line_parser const& self )
        {
          using namespace boost::spirit;
          r = (
                '#' >> lexeme_d[ str_p( "line" ) >> space_p >> uint_p[ assign_a( self.line_ ) ] ] >>
                c_strlit_parser( self.codeset_ )[ assign_a( self.file_ ) ]
              )
            | (
                '#' >>
                uint_p[ assign_a( self.line_ ) ] >>
                c_strlit_parser( self.codeset_ )[ assign_a( self.file_ ) ] >>
                *anychar_p
              );
        }
        rule_t const& start() const { return r; }
      };

      c_pp_line_parser( long& line, std::string& file, codeset_t codeset = ascii )
        : line_( line ), file_( file ), codeset_( codeset )
      {
      }

      long& line_;
      std::string& file_;
      codeset_t codeset_;
    };

    //! \#pragma ιʸ
    struct c_pp_pragma_parser : boost::spirit::grammar< c_pp_pragma_parser >
    {
      template < class Scanner >
      struct definition
      {
        typedef boost::spirit::rule< Scanner > rule_t;
        rule_t r;
        definition( c_pp_pragma_parser const& self )
        {
          using namespace boost::spirit;
          r = '#' >> lexeme_d[ str_p( "pragma" ) >> space_p >> ( +anychar_p )[ assign_a( self.parameter_ ) ] ];
        }
        rule_t const& start() const { return r; }
      };

      c_pp_pragma_parser( std::string& parameter ) : parameter_( parameter )
      {
      }
      std::string& parameter_;
    };

  }

  /*!
   *  \class  c_pp_line c_pp_line.hpp "toppers/c_pp_line.hpp"
   *  \brief  \#line뤿Υե󥯥饹
   *
   *  Υ饹 basic_text 饹Ȥ߹碌ƻѤޤ
   */
  template < class Container >
  class c_pp_line : public std::binary_function< Container, line_buf, void >
  {
  public:
    typedef Container conatiner;

    /*!
     *  \brief  󥹥ȥ饯
     *  \param  codeset ʸɻ
     */
    explicit c_pp_line( codeset_t codeset = ascii )
      : codeset_( codeset ), pragmas_( new std::vector< line_buf > )
    {
    }
    /*!
     *  \brief  ̱黻
     *  \param  cont  line_buf ǤȤ륳ƥ
     *  \param  buf   1ԥХåե
     */
    void operator()( conatiner& cont, line_buf& buf )
    {
      using namespace boost::spirit;
      long line;
      std::string file;
      detail::c_pp_line_parser c_pp_line_p( line, file, codeset_ );

      if ( parse( buf.buf.begin(), buf.buf.end(), c_pp_line_p, space_p ).full ) // #lineν
      {
        buf.line.line = line;
        assert( file.size() >= 2 );
        buf.line.file = file.substr( 1, file.size()-2 );
      }
      else
      {
        std::string param;
        detail::c_pp_pragma_parser c_pp_pragma_p( param );

        if ( parse( buf.buf.begin(), buf.buf.end(), c_pp_pragma_p, space_p ).full ) // #pragmaν
        {
          line_buf t( buf );
          t.buf = param;
          pragmas_->push_back( t );
        }
        else
        {
          std::string::size_type pos = buf.buf.find_first_not_of( " \t" );
          if ( pos == std::string::npos || buf.buf[pos] != '#' )
          {
            cont.push_back( buf );
          }
          ++buf.line.line;
        }
      }
      buf.buf.clear();
    }
    /*!
     *  \brief  \#pragmaꥹȤμ
     *  \return \#pragmaꥹȤ֤
     */
    std::vector< line_buf > const& pragmas() const { return *pragmas_; }
  private:
    codeset_t codeset_;
    std::tr1::shared_ptr< std::vector< line_buf > > pragmas_;
  };

}

#endif  // ! TOPPERS_C_PP_LINE_HPP_
